#include "v3.h"


// access to elements
float& V3::operator[](int i) {

  return xyz[i];

}

V3::V3(float x, float y, float z) {

  xyz[0] = x;
  xyz[1] = y;
  xyz[2] = z;

}

float V3::operator*(V3 v) {

  return 
    v[0]*xyz[0] + 
    v[1]*xyz[1] + 
    v[2]*xyz[2];

}


V3 V3::operator+(V3 v) {

  V3 ret(xyz[0]+v[0], xyz[1]+v[1], xyz[2]+v[2]);
  return ret;

}

V3 V3::operator-(V3 v) {

  V3 ret(xyz[0]+v[0], xyz[1]+v[1], xyz[2]+v[2]);
  return ret;

}

ostream& operator<<(ostream &ostr, V3 v) {

  ostr << v[0] << " " << v[1] << " " << v[2] << " ";
  return ostr;

}

V3 V3::operator*(float scf) {

  V3 ret = *this;
  ret[0] *= scf;
  ret[1] *= scf;
  ret[2] *= scf;
  return ret;

}
